=== debian/changelog ===
yquake2 (8.51+dfsg-2) unstable; urgency=medium

  * Re-upload to unstable

 -- Simon McVittie <smcv@debian.org>  Tue, 19 Aug 2025 08:48:24 +0100

yquake2 (8.51+dfsg-1) experimental; urgency=medium

  * New upstream release 8.51 (engine and base game)
    - Fixes savegame and mod incompatibilities if older versions were
      built in C23 mode, for example with gcc-15
  * New upstream release 1.12 (Threewave Capture the Flag, ctf)
  * New upstream release 2.15 (Mission Pack 1: The Reckoning, xatrix)
  * New upstream release 2.14 (Mission Pack 2: Ground Zero, rogue)

 -- Simon McVittie <smcv@debian.org>  Tue, 13 May 2025 12:16:07 +0100
