=== debian/changelog ===
yquake2 (8.60+dfsg-1) unstable; urgency=medium

  * New upstream release 8.60 (engine and base game)
  * New upstream release 2.16 (Mission Pack 1: The Reckoning, xatrix)
  * New upstream release 2.15 (Mission Pack 2: Ground Zero, rogue)
  * d/copyright: Update
  * d/control, d/rules: Build with SDL 3
  * d/p/debian/build-Don-t-use-SSE-on-i386.patch:
    Stop patching the upstream Makefile to avoid a SSE2 dependency.
    SSE2 is officially part of the baseline since Debian 13 'trixie'.
  * d/p/build-Don-t-hard-code-a-specific-pkg-config-executable.patch:
    Add patch to use a cross-friendly pkgconf executable to find SDL 3
  * d/control: Prefer the OpenSSL flavour of libcurl.
    There is no longer a licensing reason to avoid it, and this is the
    version that upstream recommends and tests against.
  * d/watch: Convert to v5 format
  * d/source.lintian-overrides: Silence false positive for watch file v5
  * d/salsa-ci.yml: Exercise cross-building
  * d/salsa-ci.yml: Turn off some unnecessary jobs

 -- Simon McVittie <smcv@debian.org>  Wed, 17 Sep 2025 14:41:28 +0100
