=== debian/watch ===
Version: 5

Template: Github
Owner: @PACKAGE@
Project: @PACKAGE@
Repack: yes
Compression: xz
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/QUAKE2_(\d[-+.:~0-9a-zA-Z_]*)
Filename-Mangle: s#.*/QUAKE2_##;s/_/./g;s%@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Dversion-Mangle: auto
Oversion-Mangle: s/$/+dfsg/
Uversion-Mangle: s/_/./g;s/\.RC/~rc/gi

Component: ctf
Template: Github
Owner: @PACKAGE@
Project: @COMPONENT@
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/CTF_(\d[-+.:~0-9a-zA-Z_]*)
Filename-Mangle: s#.*/CTF_##;s/_/./g;s%@ANY_VERSION@%@PACKAGE@-@COMPONENT@-$1.tar.gz%
Dversion-Mangle: auto
Oversion-Mangle: s/$/+dfsg/
Uversion-Mangle: s/_/./g;s/\.RC/~rc/gi
Version-Schema: ignore

Component: rogue
Template: Github
Owner: @PACKAGE@
Project: @COMPONENT@
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/ROGUE_(\d[-+.:~0-9a-zA-Z_]*)
Filename-Mangle: s#.*/ROGUE_##;s/_/./g;s%@ANY_VERSION@%@PACKAGE@-@COMPONENT@-$1.tar.gz%
Dversion-Mangle: auto
Oversion-Mangle: s/$/+dfsg/
Uversion-Mangle: s/_/./g;s/\.RC/~rc/gi
Version-Schema: ignore

Component: xatrix
Template: Github
Owner: @PACKAGE@
Project: @COMPONENT@
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/XATRIX_(\d[-+.:~0-9a-zA-Z_]*)
Filename-Mangle: s#.*/XATRIX_##;s/_/./g;s%@ANY_VERSION@%@PACKAGE@-@COMPONENT@-$1.tar.gz%
Dversion-Mangle: auto
Oversion-Mangle: s/$/+dfsg/
Uversion-Mangle: s/_/./g;s/\.RC/~rc/gi
Version-Schema: ignore
